; 
    include \masm32\include\masm32rt.inc
; 

comment * -----------------------------------------------------
                        Build this  template with
                       "CONSOLE ASSEMBLE AND LINK"
        ----------------------------------------------------- *

    shuffle_array PROTO :DWORD,:DWORD

    .data
      item0 db "00 zero",0
      item1 db "01 one",0
      item2 db "02 two",0
      item3 db "03 three",0
      item4 db "04 four",0
      item5 db "05 five",0
      item6 db "06 six",0
      item7 db "07 seven",0
      item8 db "08 eight",0
      item9 db "09 nine",0
      item10 db "10 ten",0
      item11 db "11 eleven",0
      item12 db "12 twelve",0
      item13 db "13 thirteen",0
      item14 db "14 fourteen",0
      item15 db "15 fifteen",0
      item16 db "16 sixteen",0
      item17 db "17 seventeen",0
      item18 db "18 eighteen",0
      item19 db "19 nineteen",0

      parr dd item0,item1,item2,item3,item4,item5,item6,item7,item8,item9,
              item10,item11,item12,item13,item14,item15,item16,item17,item18,item19

    .code

start:
   
; 

    call main
    inkey
    exit

; 

main proc

    push esi
    push edi

    mov esi, 10     ; 00000
    invoke GetTickCount
    invoke nseed, eax                   ; seed the random number generator

  @@:
    invoke shuffle_array,OFFSET parr,LENGTHOF parr
    sub esi, 1
    jnz @B


    mov esi, OFFSET parr
    mov edi, LENGTHOF parr

  @@:
    print [esi],13,10
    add esi, 4
    sub edi, 1
    jnz @B

    pop edi
    pop esi

    ret

main endp

; 

shuffle_array proc arr:DWORD,cnt:DWORD

    LOCAL lcnt  :DWORD

    mov eax, cnt            ; copy cnt to lcnt
    mov lcnt, eax

    push ebx
    push esi
    push edi

    mov esi, arr
    mov edi, arr
    xor ebx, ebx

  @@:
    invoke nrandom, cnt     ; get the random number within "cnt" range
    mov ecx, [esi+ebx*4]    ; get the incremental pointer
    mov edx, [edi+eax*4]    ; get the random pointer
    mov [esi+ebx*4], edx    ; write random pointer back to incremental location
    mov [edi+eax*4], ecx    ; write incremental pointer back to random location
    add ebx, 1              ; increment the original pointer
    sub lcnt, 1             ; decrement the loop counter
    jnz @B

    pop edi
    pop esi
    pop ebx

    ret

shuffle_array endp

; 

end start